Index: /trunk/src/sys/arch/evbmips/rmixl/machdep.c
===================================================================
--- /trunk/src/sys/arch/evbmips/rmixl/machdep.c	(revision 151)
+++ /trunk/src/sys/arch/evbmips/rmixl/machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: machdep.c,v 1.1.2.29 2010/05/06 19:49:10 cliff Exp $	*/
+/*	machdep.c,v 1.1.2.34 2011/04/29 08:26:18 matt Exp	*/
 
 /*
@@ -37,4 +37,5 @@
 
 /*
+ * Copyright (c) 1988 University of Utah.
  * Copyright (c) 1992, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -72,49 +73,12 @@
  *	from: Utah Hdr: machdep.c 1.63 91/04/24
  */
-/*
- * Copyright (c) 1988 University of Utah.
- *
- * This code is derived from software contributed to Berkeley by
- * the Systems Programming Group of the University of Utah Computer
- * Science Department, The Mach Operating System project at
- * Carnegie-Mellon University and Ralph Campbell.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. All advertising materials mentioning features or use of this software
- *    must display the following acknowledgement:
- *	This product includes software developed by the University of
- *	California, Berkeley and its contributors.
- * 4. Neither the name of the University nor the names of its contributors
- *    may be used to endorse or promote products derived from this software
- *    without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
- * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
- * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
- * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
- * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
- * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
- * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
- * SUCH DAMAGE.
- *
- *	@(#)machdep.c   8.3 (Berkeley) 1/12/94
- *	from: Utah Hdr: machdep.c 1.63 91/04/24
- */
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.1.2.29 2010/05/06 19:49:10 cliff Exp $");
+__KERNEL_RCSID(0, "machdep.c,v 1.1.2.34 2011/04/29 08:26:18 matt Exp");
 
 #define __INTR_PRIVATE
-
+#define __MUTEX_PRIVATE
+
+#include "opt_multiprocessor.h"
 #include "opt_ddb.h"
 #include "opt_com.h"
@@ -129,5 +93,4 @@
 #include <sys/buf.h>
 #include <sys/reboot.h>
-#include <sys/user.h>
 #include <sys/mount.h>
 #include <sys/kcore.h>
@@ -147,10 +110,12 @@
 
 #if NKSYMS || defined(DDB) || defined(LKM)
-#include <machine/db_machdep.h>
+#include <mips/db_machdep.h>
 #include <ddb/db_extern.h>
 #endif
 
-#include <machine/cpu.h>
-#include <machine/psl.h>
+#include <mips/cpu.h>
+#include <mips/psl.h>
+#include <mips/cache.h>
+#include <mips/mips_opcode.h>
 
 #include "com.h"
@@ -213,4 +178,5 @@
 	{	0x4aacdb6a00000056ULL, PSB_TYPE_RMI  },
 	{	0x4b67d03200000056ULL, PSB_TYPE_RMI  },
+	{	0x4c17058b00000056ULL, PSB_TYPE_RMI  },
 	{	0x49a5a8fa00000056ULL, PSB_TYPE_DELL },
 	{	0x4b8ead3100000056ULL, PSB_TYPE_DELL },
@@ -267,11 +233,5 @@
 #endif	/* MACHDEP_DEBUG */
 #endif	/* MULTIPROCESSOR */
-
-
-/*
- * safepri is a safe priority for sleep to set for a spin-wait during
- * autoconfiguration or after a panic.  Used as an argument to splx().
- */
-int	safepri = MIPS1_PSL_LOWIPL;
+static void rmixl_fixup_curcpu(void);
 
 /*
@@ -284,17 +244,7 @@
 	void *kernend;
 	uint64_t memsize;
-	uint32_t r;
 	extern char edata[], end[];
 
-#ifndef MULTIPROCESSOR
-	rmixl_mtcr(0, 1);		/* disable all threads except #0 */
-	rmixl_mtcr(0x400, 0);		/* enable MMU clock gating */
-					/* set single MMU Thread Mode */
-					/* TLB is partitioned (1 partition) */
-#endif
-
-	r = rmixl_mfcr(0x300);
-	r &= ~__BIT(14);		/* disabled Unaligned Access */
-	rmixl_mtcr(0x300, r);
+	rmixl_pcr_init_core();
 
 	/*
@@ -313,5 +263,9 @@
 	 * specify chip-specific EIRR/EIMR based spl functions
 	 */
-	mips_vector_init(&rmixl_splsw);
+#ifdef MULTIPROCESSOR
+	mips_vector_init(&rmixl_splsw, true);
+#else
+	mips_vector_init(&rmixl_splsw, false);
+#endif
 
 	/* mips_vector_init initialized mips_options */
@@ -449,5 +403,5 @@
 
 	/*
-	 * Allocate space for proc0's USPACE.
+	 * Allocate uarea page for lwp0 and set it.
 	 */
 	mips_init_lwp0_uarea();
@@ -464,5 +418,4 @@
 		Debugger();
 #endif
-#ifdef MULTIPROCESSOR
 	/*
 	 * store (cpu#0) curcpu in COP0 OSSCRATCH0
@@ -471,5 +424,46 @@
 	__asm __volatile("dmtc0 %0,$%1"
 		:: "r"(&cpu_info_store), "n"(MIPS_COP_0_OSSCRATCH));
+#ifdef MULTIPROCESSOR
+	__asm __volatile("dmtc0 %0,$%1,2"
+		:: "r"(&pmap_tlb0_info.ti_lock->mtx_lock),
+		    "n"(MIPS_COP_0_OSSCRATCH));
 	mips_fixup_exceptions(rmixl_fixup_cop0_oscratch);
+#endif
+	rmixl_fixup_curcpu();
+}
+
+/*
+ * set up Processor Control Regs for this core
+ */
+void
+rmixl_pcr_init_core()
+{
+	uint32_t r;
+
+#ifdef MULTIPROCESSOR
+	rmixl_mtcr(RMIXL_PCR_MMU_SETUP, __BITS(2,0));
+						/* enable MMU clock gating */
+						/* 4 threads active -- why needed if Global? */
+						/* enable global TLB mode */
+#else
+	rmixl_mtcr(RMIXL_PCR_THREADEN, 1);	/* disable all threads except #0 */
+	rmixl_mtcr(RMIXL_PCR_MMU_SETUP, 0);	/* enable MMU clock gating */
+						/* set single MMU Thread Mode */
+						/* TLB is partitioned (1 partition) */
+#endif
+
+	r = rmixl_mfcr(RMIXL_PCR_L1D_CONFIG0);
+	r &= ~__BIT(14);			/* disable Unaligned Access */
+	rmixl_mtcr(RMIXL_PCR_L1D_CONFIG0, r);
+
+#if defined(DDB) && defined(MIPS_DDB_WATCH)
+	/*
+	 * clear IEU_DEFEATURE[DBE]
+	 * this enables COP0 watchpoint to trigger T_WATCH exception
+	 * instead of signaling JTAG.
+	 */
+	r = rmixl_mfcr(RMIXL_PCR_IEU_DEFEATURE);
+	r &= ~__BIT(7);
+	rmixl_mtcr(RMIXL_PCR_IEU_DEFEATURE, r);
 #endif
 }
@@ -498,5 +492,5 @@
 	    | (MIPS_COP_0_OSSCRATCH << 11) | (0 << 0);
 
-	/* [1] = l[dw] rX, offset(rX) */
+	/* [1] = [ls][dw] rX, offset(rX) */
 	new_insns[1] = (new_insns[1] & 0xffff0000) | offset;
 
@@ -504,4 +498,41 @@
 }
 #endif /* MULTIPROCESSOR */
+
+/*
+ * The following changes all	lX	rN, L_CPU(MIPS_CURLWP) [curlwp->l_cpu]
+ * to			     	[d]mfc0	rN, $22 [MIPS_COP_0_OSSCRATCH]
+ *
+ * the mfc0 is 3 cycles shorter than the load.
+ */
+#define	LOAD_CURCPU_0	((MIPS_CURLWP_REG << 21) | offsetof(lwp_t, l_cpu))
+#define	MFC0_CURCPU_0	((OP_COP0 << 26) | (MIPS_COP_0_OSSCRATCH << 11))
+#ifdef _LP64
+#define	LOAD_CURCPU	((uint32_t)(OP_LD << 26) | LOAD_CURCPU_0)
+#define	MFC0_CURCPU	((uint32_t)(OP_DMF << 21) | MFC0_CURCPU_0)
+#else
+#define	LOAD_CURCPU	((uint32_t)(OP_LW << 26) | LOAD_CURCPU_0)
+#define	MFC0_CURCPU	((uint32_t)(OP_MF << 21) | MFC0_CURCPU_0)
+#endif
+#define	LOAD_CURCPU_MASK	0xffe0ffff
+
+static void
+rmixl_fixup_curcpu(void)
+{
+	extern uint32_t _ftext[];
+	extern uint32_t _etext[];
+
+	for (uint32_t *insnp = _ftext; insnp < _etext; insnp++) {
+		const uint32_t insn = *insnp;
+		if (__predict_false((insn & LOAD_CURCPU_MASK) == LOAD_CURCPU)) {
+			/*
+			 * Since the register to loaded is located in bits
+			 * 16-20 for the mfc0 and the load instruction we can
+			 * just change the instruction bits around it.
+			 */
+			*insnp = insn ^ LOAD_CURCPU ^ MFC0_CURCPU;
+			mips_icache_sync_range((vaddr_t)insnp, 4);
+		}
+	}
+}
 
 /*
@@ -1003,11 +1034,9 @@
 
 void
-cpu_reboot(howto, bootstr)
-	int howto;
-	char *bootstr;
+cpu_reboot(int howto, char *bootstr)
 {
 
 	/* Take a snapshot before clobbering any registers. */
-	savectx(curlwp->l_addr);
+	savectx(lwp_getpcb(curlwp));
 
 	if (cold) {
Index: /trunk/src/sys/arch/ews4800mips/ews4800mips/autoconf.c
===================================================================
--- /trunk/src/sys/arch/ews4800mips/ews4800mips/autoconf.c	(revision 151)
+++ /trunk/src/sys/arch/ews4800mips/ews4800mips/autoconf.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: autoconf.c,v 1.7 2008/04/28 20:23:18 martin Exp $	*/
+/*	$NetBSD: autoconf.c,v 1.7.18.1 2010/12/29 08:16:21 matt Exp $	*/
 
 /*-
@@ -28,5 +28,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: autoconf.c,v 1.7 2008/04/28 20:23:18 martin Exp $");
+__KERNEL_RCSID(0, "$NetBSD: autoconf.c,v 1.7.18.1 2010/12/29 08:16:21 matt Exp $");
 
 #include "opt_sbd.h"
@@ -36,4 +36,5 @@
 #include <sys/conf.h>
 #include <sys/device.h>
+#include <sys/intr.h>
 
 #include <machine/sbdvar.h>
@@ -51,5 +52,5 @@
 	if (config_rootfound("mainbus", NULL) == NULL)
 		panic("no mainbus found");
-	_splnone();
+	spl0();
 }
 
Index: /trunk/src/sys/arch/ews4800mips/ews4800mips/interrupt.c
===================================================================
--- /trunk/src/sys/arch/ews4800mips/ews4800mips/interrupt.c	(revision 151)
+++ /trunk/src/sys/arch/ews4800mips/ews4800mips/interrupt.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: interrupt.c,v 1.4.18.1 2010/02/05 07:39:53 matt Exp $	*/
+/*	$NetBSD: interrupt.c,v 1.4.18.2 2010/12/29 08:16:21 matt Exp $	*/
 
 /*-
@@ -31,5 +31,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: interrupt.c,v 1.4.18.1 2010/02/05 07:39:53 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: interrupt.c,v 1.4.18.2 2010/12/29 08:16:21 matt Exp $");
 
 #include <sys/param.h>
@@ -40,6 +40,5 @@
 #include <machine/sbdvar.h>
 
-const uint32_t *ipl_sr_bits;
-static void (*platform_intr)(uint32_t, uint32_t, uint32_t, uint32_t);
+static void (*platform_intr)(int, vaddr_t, uint32_t);
 
 void
@@ -66,20 +65,8 @@
 
 void
-cpu_intr(uint32_t status, uint32_t cause, uint32_t pc, uint32_t ipending)
+cpu_intr(int ppl, vaddr_t pc, uint32_t status)
 {
-	struct cpu_info *ci;
-
-	ci = curcpu();
 	uvmexp.intrs++;
 
-	ci->ci_idepth++;
-	(*platform_intr)(status, cause, pc, ipending);
-	ci->ci_idepth--;
-
-#ifdef __HAVE_FAST_SOFTINTS
-	ipending &= MIPS_SOFT_INT_MASK;
-	if (ipending == 0)
-		return;
-	softint_process(ipending);
-#endif
+	(*platform_intr)(ppl, pc, status);
 }
Index: /trunk/src/sys/arch/ews4800mips/ews4800mips/mainbus.c
===================================================================
--- /trunk/src/sys/arch/ews4800mips/ews4800mips/mainbus.c	(revision 151)
+++ /trunk/src/sys/arch/ews4800mips/ews4800mips/mainbus.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: mainbus.c,v 1.4 2008/04/28 20:23:18 martin Exp $	*/
+/*	$NetBSD: mainbus.c,v 1.4.18.1 2010/12/29 08:16:21 matt Exp $	*/
 
 /*-
@@ -28,5 +28,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: mainbus.c,v 1.4 2008/04/28 20:23:18 martin Exp $");
+__KERNEL_RCSID(0, "$NetBSD: mainbus.c,v 1.4.18.1 2010/12/29 08:16:21 matt Exp $");
 
 #include <sys/param.h>
@@ -60,5 +60,5 @@
 {
 	struct mainbus_attach_args ma;
-	const char **p;
+	const char * const *p;
 
 	mainbus_found = 1;
Index: /trunk/src/sys/arch/ews4800mips/ews4800mips/tr2.c
===================================================================
--- /trunk/src/sys/arch/ews4800mips/ews4800mips/tr2.c	(revision 151)
+++ /trunk/src/sys/arch/ews4800mips/ews4800mips/tr2.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: tr2.c,v 1.3.18.1 2010/01/20 09:04:33 matt Exp $	*/
+/*	$NetBSD: tr2.c,v 1.3.18.2 2010/12/29 08:16:21 matt Exp $	*/
 
 /*-
@@ -31,6 +31,7 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: tr2.c,v 1.3.18.1 2010/01/20 09:04:33 matt Exp $");
-
+__KERNEL_RCSID(0, "$NetBSD: tr2.c,v 1.3.18.2 2010/12/29 08:16:21 matt Exp $");
+
+#define __INTR_PRIVATE
 #include "fb_sbdio.h"
 #include "kbms_sbdio.h"
@@ -60,5 +61,5 @@
 
 /* EWS4800/350 mainbus device list */
-static const char *tr2_mainbusdevs[] =
+static const char * const tr2_mainbusdevs[] =
 {
 	"sbdio",
@@ -103,5 +104,5 @@
 	platform.sbdiodevs = tr2_sbdiodevs;
 
-	ipl_sr_bits = tr2_sr_bits;
+	ipl_sr_map = tr2_ipl_sr_map;
 
 	kseg2iobufsize = 0x02000000;	/* 32MB for VME and framebuffer */
Index: /trunk/src/sys/arch/ews4800mips/ews4800mips/tr2_intr.c
===================================================================
--- /trunk/src/sys/arch/ews4800mips/ews4800mips/tr2_intr.c	(revision 151)
+++ /trunk/src/sys/arch/ews4800mips/ews4800mips/tr2_intr.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: tr2_intr.c,v 1.10 2008/04/28 20:23:18 martin Exp $	*/
+/*	$NetBSD: tr2_intr.c,v 1.10.18.1 2010/12/29 08:16:21 matt Exp $	*/
 
 /*-
@@ -31,10 +31,13 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: tr2_intr.c,v 1.10 2008/04/28 20:23:18 martin Exp $");
-
+__KERNEL_RCSID(0, "$NetBSD: tr2_intr.c,v 1.10.18.1 2010/12/29 08:16:21 matt Exp $");
+
+#define	__INTR_PRIVATE
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/kernel.h>
-#include <sys/device.h>
+#include <sys/evcnt.h>
+#include <sys/cpu.h>
+#include <sys/lwp.h>
 #include <sys/intr.h>
 
@@ -48,21 +51,22 @@
 SBD_DECL(tr2);
 
-const uint32_t tr2_sr_bits[_IPL_N] = {
-	[IPL_NONE] = 0,
-	[IPL_SOFTCLOCK] = MIPS_SOFT_INT_MASK_0,
-	[IPL_SOFTNET] =
-	    MIPS_SOFT_INT_MASK_0 | MIPS_SOFT_INT_MASK_1,
-	[IPL_VM] =
-	    MIPS_SOFT_INT_MASK_0 | MIPS_SOFT_INT_MASK_1 |
-	    MIPS_INT_MASK_0 |
-	    MIPS_INT_MASK_2 |
-	    MIPS_INT_MASK_4,
-	[IPL_SCHED] =
-	    MIPS_SOFT_INT_MASK_0 | MIPS_SOFT_INT_MASK_1 |
-	    MIPS_INT_MASK_0 |
-	    MIPS_INT_MASK_2 |
-	    MIPS_INT_MASK_4 |
-	    MIPS_INT_MASK_5,
+const struct ipl_sr_map tr2_ipl_sr_map = {
+    {
+	[IPL_NONE] =		0,
+	[IPL_SOFTCLOCK] =	MIPS_SOFT_INT_MASK_0,
+	[IPL_SOFTNET] =		MIPS_SOFT_INT_MASK,
+	[IPL_VM] =		MIPS_SOFT_INT_MASK
+				| MIPS_INT_MASK_0
+				| MIPS_INT_MASK_2
+				| MIPS_INT_MASK_4,
+	[IPL_SCHED] =		MIPS_SOFT_INT_MASK
+				| MIPS_INT_MASK_0
+				| MIPS_INT_MASK_2
+				| MIPS_INT_MASK_4
+				| MIPS_INT_MASK_5,
+	[IPL_DDB] =		MIPS_INT_MASK,
+	[IPL_HIGH] =		MIPS_INT_MASK,
 	/* !!! TEST !!! VME INTERRUPT IS NOT MASKED */
+    },
 };
 
@@ -140,119 +144,114 @@
 
 void
-tr2_intr(uint32_t status, uint32_t cause, uint32_t pc, uint32_t ipending)
+tr2_intr(int ppl, vaddr_t pc, uint32_t status)
 {
 	struct tr2_intr_handler *ih;
 	struct clockframe cf;
-	uint32_t r, handled;
-
-	handled = 0;
-
-	if (ipending & MIPS_INT_MASK_5) {	/* CLOCK */
-		cf.pc = pc;
-		cf.sr = status;
-
-		*PICNIC_INT5_STATUS_REG = 0;
-		r = *PICNIC_INT5_STATUS_REG;
-
-		hardclock(&cf);
-		timer_tr2_ev.ev_count++;
-		handled |= MIPS_INT_MASK_5;
+	uint32_t r, ipending;
+	int ipl;
+
+	while (ppl < (ipl = splintr(&ipending))) {
+		if (ipending & MIPS_INT_MASK_5) {	/* CLOCK */
+			cf.pc = pc;
+			cf.sr = status;
+			cf.intr = (curcpu()->ci_idepth > 0);
+
+			*PICNIC_INT5_STATUS_REG = 0;
+			r = *PICNIC_INT5_STATUS_REG;
+
+			hardclock(&cf);
+			timer_tr2_ev.ev_count++;
+		}
+
+		if (ipending & MIPS_INT_MASK_4) {	/* KBD, MOUSE, SERIAL */
+			r = *PICNIC_INT4_STATUS_REG;
+
+			if (r & PICNIC_INT_KBMS) {
+				ih = &tr2_intr_handler[0];
+				if (ih->func) {
+					ih->func(ih->arg);
+					ih->evcnt.ev_count++;
+				}
+				r &= ~PICNIC_INT_KBMS;
+			}
+
+			if (r & PICNIC_INT_SERIAL) {
+#if 0
+				printf("SIO interrupt\n");
+#endif
+				ih = &tr2_intr_handler[2];
+				if (ih->func) {
+					ih->func(ih->arg);
+					ih->evcnt.ev_count++;
+				}
+				r &= ~PICNIC_INT_SERIAL;
+			}
+		}
+
+		if (ipending & MIPS_INT_MASK_3) {	/* VME */
+			printf("VME interrupt\n");
+
+			r = *(volatile uint32_t *)0xbfb00018; /* NABI? */
+			if ((r & 0x10) != 0) {
+				/* vme high interrupt */
+			} else if ((r & 0x4) != 0) {
+				/* vme lo interrupt */
+			} else {
+				/* error */
+			}
+		}
+
+		if (ipending & MIPS_INT_MASK_2) {	/* ETHER, SCSI */
+			r = *PICNIC_INT2_STATUS_REG;
+
+			if (r & PICNIC_INT_ETHER) {
+				ih = &tr2_intr_handler[6];
+				if (ih->func) {
+					ih->func(ih->arg);
+					ih->evcnt.ev_count++;
+				}
+				r &= ~PICNIC_INT_ETHER;
+			}
+
+			if (r & PICNIC_INT_SCSI) {
+				ih = &tr2_intr_handler[5];
+				if (ih->func) {
+					ih->func(ih->arg);
+					ih->evcnt.ev_count++;
+				}
+				r &= ~PICNIC_INT_SCSI;
+			}
+
+			if ((r & PICNIC_INT_FDDLPT) &&
+			    (ipending & MIPS_INT_MASK_5)) {
+#ifdef DEBUG
+				printf("FDD LPT interrupt\n");
+#endif
+				ih = &tr2_intr_handler[7];
+				if (ih->func) {
+					ih->func(ih->arg);
+					ih->evcnt.ev_count++;
+				}
+				r &= ~PICNIC_INT_FDDLPT;
+			}
+		}
+
+		if (ipending & MIPS_INT_MASK_1)
+			panic("unknown interrupt INT1\n");
+
+		if (ipending & MIPS_INT_MASK_0) {	/* FDD, PRINTER */
+#ifdef DEBUG
+			printf("printer, printer interrupt\n");
+#endif
+			r = *PICNIC_INT0_STATUS_REG;
+			if (r & PICNIC_INT_FDDLPT) {
+#ifdef DEBUG
+				printf("FDD, Printer interrupt.\n");
+#endif
+			} else {
+				printf("unknown interrupt INT0\n");
+			}
+		}
 	}
-	_splset((status & handled) | MIPS_SR_INT_IE);
-
-	if (ipending & MIPS_INT_MASK_4) {	/* KBD, MOUSE, SERIAL */
-		r = *PICNIC_INT4_STATUS_REG;
-
-		if (r & PICNIC_INT_KBMS) {
-			ih = &tr2_intr_handler[0];
-			if (ih->func) {
-				ih->func(ih->arg);
-				ih->evcnt.ev_count++;
-			}
-			r &= ~PICNIC_INT_KBMS;
-		}
-
-		if (r & PICNIC_INT_SERIAL) {
-#if 0
-			printf("SIO interrupt\n");
-#endif
-			ih = &tr2_intr_handler[2];
-			if (ih->func) {
-				ih->func(ih->arg);
-				ih->evcnt.ev_count++;
-			}
-			r &= ~PICNIC_INT_SERIAL;
-		}
-
-		handled |= MIPS_INT_MASK_4;
-	}
-	_splset((status & handled) | MIPS_SR_INT_IE);
-
-	if (ipending & MIPS_INT_MASK_3) {	/* VME */
-		printf("VME interrupt\n");
-
-		r = *(volatile uint32_t *)0xbfb00018; /* NABI? */
-		if ((r & 0x10) != 0) {
-			/* vme high interrupt */
-		} else if ((r & 0x4) != 0) {
-			/* vme lo interrupt */
-		} else {
-			/* error */
-		}
-	}
-
-	if (ipending & MIPS_INT_MASK_2) {	/* ETHER, SCSI */
-		r = *PICNIC_INT2_STATUS_REG;
-
-		if (r & PICNIC_INT_ETHER) {
-			ih = &tr2_intr_handler[6];
-			if (ih->func) {
-				ih->func(ih->arg);
-				ih->evcnt.ev_count++;
-			}
-			r &= ~PICNIC_INT_ETHER;
-		}
-
-		if (r & PICNIC_INT_SCSI) {
-			ih = &tr2_intr_handler[5];
-			if (ih->func) {
-				ih->func(ih->arg);
-				ih->evcnt.ev_count++;
-			}
-			r &= ~PICNIC_INT_SCSI;
-		}
-
-		if ((r & PICNIC_INT_FDDLPT) &&
-		    ((cause & status) & MIPS_INT_MASK_5)) {
-#ifdef DEBUG
-			printf("FDD LPT interrupt\n");
-#endif
-			ih = &tr2_intr_handler[7];
-			if (ih->func) {
-				ih->func(ih->arg);
-				ih->evcnt.ev_count++;
-			}
-			r &= ~PICNIC_INT_FDDLPT;
-		}
-
-		handled |= MIPS_INT_MASK_2;
-	}
-	_splset((status & handled) | MIPS_SR_INT_IE);
-
-	if (ipending & MIPS_INT_MASK_1)
-		panic("unknown interrupt INT1\n");
-
-	if (ipending & MIPS_INT_MASK_0) {	/* FDD, PRINTER */
-		printf("printer, printer interrupt\n");
-		r = *PICNIC_INT0_STATUS_REG;
-		if (r & PICNIC_INT_FDDLPT) {
-			printf("FDD, Printer interrupt.\n");
-		} else {
-			printf("unknown interrupt INT0\n");
-		}
-		handled |= MIPS_INT_MASK_0;
-	}
-	cause &= ~handled;
-	_splset(((status & ~cause) & MIPS_HARD_INT_MASK) | MIPS_SR_INT_IE);
 }
 
Index: /trunk/src/sys/arch/ews4800mips/ews4800mips/tr2a.c
===================================================================
--- /trunk/src/sys/arch/ews4800mips/ews4800mips/tr2a.c	(revision 151)
+++ /trunk/src/sys/arch/ews4800mips/ews4800mips/tr2a.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: tr2a.c,v 1.3.18.1 2010/01/20 09:04:33 matt Exp $	*/
+/*	$NetBSD: tr2a.c,v 1.3.18.2 2010/12/29 08:16:21 matt Exp $	*/
 
 /*-
@@ -31,6 +31,7 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: tr2a.c,v 1.3.18.1 2010/01/20 09:04:33 matt Exp $");
-
+__KERNEL_RCSID(0, "$NetBSD: tr2a.c,v 1.3.18.2 2010/12/29 08:16:21 matt Exp $");
+
+#define __INTR_PRIVATE
 #include "fb_sbdio.h"
 #include "kbms_sbdio.h"
@@ -60,5 +61,5 @@
 
 /* EWS4800/360 bus list */
-static const char *tr2a_mainbusdevs[] = {
+static const char * const tr2a_mainbusdevs[] = {
 	"sbdio",
 #ifdef notyet
@@ -152,5 +153,5 @@
 		platform.sbdiodevs = tr2a_sbdiodevs;
 
-	ipl_sr_bits = tr2a_sr_bits;
+	ipl_sr_map = tr2a_ipl_sr_map;
 
 	kseg2iobufsize = 0x02000000;	/* 32MB for APbus and framebuffer */
Index: /trunk/src/sys/arch/ews4800mips/ews4800mips/tr2a_intr.c
===================================================================
--- /trunk/src/sys/arch/ews4800mips/ews4800mips/tr2a_intr.c	(revision 151)
+++ /trunk/src/sys/arch/ews4800mips/ews4800mips/tr2a_intr.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: tr2a_intr.c,v 1.12 2008/04/28 20:23:18 martin Exp $	*/
+/*	$NetBSD: tr2a_intr.c,v 1.12.18.1 2010/12/29 08:16:21 matt Exp $	*/
 
 /*-
@@ -31,10 +31,13 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: tr2a_intr.c,v 1.12 2008/04/28 20:23:18 martin Exp $");
-
+__KERNEL_RCSID(0, "$NetBSD: tr2a_intr.c,v 1.12.18.1 2010/12/29 08:16:21 matt Exp $");
+
+#define __INTR_PRIVATE
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/kernel.h>
 #include <sys/evcnt.h>
+#include <sys/lwp.h>
+#include <sys/cpu.h>
 #include <sys/intr.h>
 
@@ -46,25 +49,14 @@
 SBD_DECL(tr2a);
 
-const uint32_t tr2a_sr_bits[_IPL_N] = {
+const struct ipl_sr_map tr2a_ipl_sr_map = {
+    .sr_bits = {
 	[IPL_NONE] = 0,
-	[IPL_SOFTCLOCK] =
-	    MIPS_SOFT_INT_MASK_0,
-	[IPL_SOFTNET] =
-	    MIPS_SOFT_INT_MASK_0 | MIPS_SOFT_INT_MASK_1,
-	[IPL_VM] =
-	    MIPS_SOFT_INT_MASK_0 | MIPS_SOFT_INT_MASK_1 |
-	    MIPS_INT_MASK_0 |
-	    MIPS_INT_MASK_1 |
-	    MIPS_INT_MASK_2 |
-	    MIPS_INT_MASK_3 |
-	    MIPS_INT_MASK_4,
-	[IPL_SCHED] =
-	    MIPS_SOFT_INT_MASK_0 | MIPS_SOFT_INT_MASK_1 |
-	    MIPS_INT_MASK_0 |
-	    MIPS_INT_MASK_1 |
-	    MIPS_INT_MASK_2 |
-	    MIPS_INT_MASK_3 |
-	    MIPS_INT_MASK_4 |
-	    MIPS_INT_MASK_5,
+	[IPL_SOFTCLOCK] =	MIPS_SOFT_INT_MASK_0,
+	[IPL_SOFTNET] =		MIPS_SOFT_INT_MASK,
+	[IPL_VM] =		MIPS_INT_MASK & ~MIPS_INT_MASK_5,
+	[IPL_SCHED] =		MIPS_INT_MASK,
+	[IPL_DDB] =		MIPS_INT_MASK,
+	[IPL_HIGH] =		MIPS_INT_MASK,
+    },
 };
 
@@ -179,132 +171,122 @@
 
 void
-tr2a_intr(uint32_t status, uint32_t cause, uint32_t pc, uint32_t ipending)
+tr2a_intr(int ppl, vaddr_t pc, uint32_t status)
 {
 	struct tr2a_intr_handler *ih;
 	struct clockframe cf;
-	uint32_t r, intc_cause, handled;
-
-	handled = 0;
+	uint32_t r, intc_cause, ipending;
+	int ipl;
+
 	intc_cause = *INTC_STATUS_REG & *INTC_MASK_REG;
 
-	if ((ipending & MIPS_INT_MASK_5) && (intc_cause & INTC_INT5)) {
-		cf.pc = pc;
-		cf.sr = status;
-		tr2a_wbflush();
-		*INTC_CLEAR_REG = 0x7c;
-		*INTC_STATUS_REG;
-
-		hardclock(&cf);
-		timer_tr2a_ev.ev_count++;
-		handled |= MIPS_INT_MASK_5;
+	while (ppl < (ipl = splintr(&ipending))) {
+		if ((ipending & MIPS_INT_MASK_5) && (intc_cause & INTC_INT5)) {
+			cf.pc = pc;
+			cf.sr = status;
+			cf.intr = (curcpu()->ci_idepth > 0);
+			tr2a_wbflush();
+			*INTC_CLEAR_REG = 0x7c;
+			*INTC_STATUS_REG;
+
+			hardclock(&cf);
+			timer_tr2a_ev.ev_count++;
+		}
+
+		if ((ipending & MIPS_INT_MASK_4) && (intc_cause & INTC_INT4)) {
+			/* KBD, MOUSE, SERIAL */
+			r = *ASO_INT_STATUS_REG;
+			if (r & 0x300010) {
+				ih = &tr2a_intr_handler[4];
+				if (ih->func) {
+					ih->func(ih->arg);
+					ih->evcnt.ev_count++;
+				}
+			} else if (r & 0x40) {
+				/* kbms */
+				ih = &tr2a_intr_handler[9];
+				if (ih->func) {
+					ih->func(ih->arg);
+					ih->evcnt.ev_count++;
+				}
+			} else if (r & 0x20) {
+				printf("INT4 (1)\n");
+			} else if (r & 0x00800000) {
+				printf("INT4 (2)\n");
+			} else if (r & 0x00400000) {
+				printf("INT4 (3)\n");
+			} else if (r != 0) {
+				printf("not for INT4 %x\n", r);
+			}
+
+			tr2a_wbflush();
+			*INTC_CLEAR_REG = 0x68;
+			*INTC_STATUS_REG;
+		}
+
+		if ((ipending & MIPS_INT_MASK_3) && (intc_cause & INTC_INT3)) {
+			/* APbus HI */
+			printf("APbus HI\n");
+			tr2a_wbflush();
+			*INTC_CLEAR_REG = 0x54;
+			*INTC_STATUS_REG;
+		}
+
+		if ((ipending & MIPS_INT_MASK_2) && (intc_cause & INTC_INT2)) {
+			/* SCSI, ETHER */
+			r = *ASO_INT_STATUS_REG;
+			if (r & 0x100) {	/* SCSI-A */
+				ih = &tr2a_intr_handler[6];
+				if (ih->func) {
+					ih->func(ih->arg);
+					ih->evcnt.ev_count++;
+				}
+			} else if (r & 0x200) {	/* SCSI-B */
+				ih = &tr2a_intr_handler[10];
+				if (ih->func) {
+					ih->func(ih->arg);
+					ih->evcnt.ev_count++;
+				}
+			} else if (r & 0x1) {	/* LANCE */
+				ih = &tr2a_intr_handler[0];
+				if (ih->func) {
+					ih->func(ih->arg);
+					ih->evcnt.ev_count++;
+				}
+			} else if (r != 0) {
+				printf("not for INT2 %x %x\n", r,
+				    *ASO_DMAINT_STATUS_REG);
+			}
+
+			tr2a_wbflush();
+			*INTC_CLEAR_REG = 0x40;
+			*INTC_STATUS_REG;
+		}
+
+		if ((ipending & MIPS_INT_MASK_1) && (intc_cause & INTC_INT1)) {
+			/* APbus LO */
+			printf("APbus LO\n");
+			tr2a_wbflush();
+			*INTC_CLEAR_REG = 0x2c;
+			*INTC_STATUS_REG;
+		}
+
+		if ((ipending & MIPS_INT_MASK_0) && (intc_cause & INTC_INT0)) {
+			/* NMI etc. */
+			r = *ASO_INT_STATUS_REG;
+			printf("INT0 %08x\n", r);
+			if (r & 0x8000) {
+				printf("INT0(1) NMI\n");
+			} else if (r & 0x8) {
+				printf("INT0(2)\n");
+			} else if (r & 0x4) {
+				printf("INT0(3)\n");
+			} else if (r != 0) {
+				printf("not for INT0 %x\n", r);
+			}
+			tr2a_wbflush();
+			*INTC_CLEAR_REG = 0x14;
+			*INTC_STATUS_REG;
+		}
 	}
-	_splset((status & handled) | MIPS_SR_INT_IE);
-
-
-	if ((ipending & MIPS_INT_MASK_4) && (intc_cause & INTC_INT4)) {
-		/* KBD, MOUSE, SERIAL */
-		r = *ASO_INT_STATUS_REG;
-		if (r & 0x300010) {
-			ih = &tr2a_intr_handler[4];
-			if (ih->func) {
-				ih->func(ih->arg);
-				ih->evcnt.ev_count++;
-			}
-		} else if (r & 0x40) {
-			/* kbms */
-			ih = &tr2a_intr_handler[9];
-			if (ih->func) {
-				ih->func(ih->arg);
-				ih->evcnt.ev_count++;
-			}
-		} else if (r & 0x20) {
-			printf("INT4 (1)\n");
-		} else if (r & 0x00800000) {
-			printf("INT4 (2)\n");
-		} else if (r & 0x00400000) {
-			printf("INT4 (3)\n");
-		} else if (r != 0) {
-			printf("not for INT4 %x\n", r);
-		}
-
-		tr2a_wbflush();
-		*INTC_CLEAR_REG = 0x68;
-		*INTC_STATUS_REG;
-
-		handled |= MIPS_INT_MASK_4;
-	}
-	_splset((status & handled) | MIPS_SR_INT_IE);
-
-	if ((ipending & MIPS_INT_MASK_3) && (intc_cause & INTC_INT3)) {
-		/* APbus HI */
-		printf("APbus HI\n");
-		tr2a_wbflush();
-		*INTC_CLEAR_REG = 0x54;
-		*INTC_STATUS_REG;
-		handled |= MIPS_INT_MASK_3;
-	}
-
-	if ((ipending & MIPS_INT_MASK_2) && (intc_cause & INTC_INT2)) {
-		/* SCSI, ETHER */
-		r = *ASO_INT_STATUS_REG;
-		if (r & 0x100) {	/* SCSI-A */
-			ih = &tr2a_intr_handler[6];
-			if (ih->func) {
-				ih->func(ih->arg);
-				ih->evcnt.ev_count++;
-			}
-		} else if (r & 0x200) {	/* SCSI-B */
-			ih = &tr2a_intr_handler[10];
-			if (ih->func) {
-				ih->func(ih->arg);
-				ih->evcnt.ev_count++;
-			}
-		} else if (r & 0x1) {	/* LANCE */
-			ih = &tr2a_intr_handler[0];
-			if (ih->func) {
-				ih->func(ih->arg);
-				ih->evcnt.ev_count++;
-			}
-		} else if (r != 0) {
-			printf("not for INT2 %x %x\n", r,
-			    *ASO_DMAINT_STATUS_REG);
-		}
-
-		tr2a_wbflush();
-		*INTC_CLEAR_REG = 0x40;
-		*INTC_STATUS_REG;
-		handled |= MIPS_INT_MASK_2;
-	}
-	_splset((status & handled) | MIPS_SR_INT_IE);
-
-	if ((ipending & MIPS_INT_MASK_1) && (intc_cause & INTC_INT1)) {
-		/* APbus LO */
-		printf("APbus LO\n");
-		tr2a_wbflush();
-		*INTC_CLEAR_REG = 0x2c;
-		*INTC_STATUS_REG;
-		handled |= MIPS_INT_MASK_1;
-	}
-
-	if ((ipending & MIPS_INT_MASK_0) && (intc_cause & INTC_INT0)) {
-		/* NMI etc. */
-		r = *ASO_INT_STATUS_REG;
-		printf("INT0 %08x\n", r);
-		if (r & 0x8000) {
-			printf("INT0(1) NMI\n");
-		} else if (r & 0x8) {
-			printf("INT0(2)\n");
-		} else if (r & 0x4) {
-			printf("INT0(3)\n");
-		} else if (r != 0) {
-			printf("not for INT0 %x\n", r);
-		}
-		tr2a_wbflush();
-		*INTC_CLEAR_REG = 0x14;
-		*INTC_STATUS_REG;
-		handled |= MIPS_INT_MASK_0;
-	}
-	cause &= ~handled;
-	_splset(((status & ~cause) & MIPS_HARD_INT_MASK) | MIPS_SR_INT_IE);
 }
 
Index: /trunk/src/sys/arch/ews4800mips/include/intr.h
===================================================================
--- /trunk/src/sys/arch/ews4800mips/include/intr.h	(revision 151)
+++ /trunk/src/sys/arch/ews4800mips/include/intr.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: intr.h,v 1.10 2008/04/28 20:23:18 martin Exp $	*/
+/*	$NetBSD: intr.h,v 1.10.18.1 2010/12/29 08:16:22 matt Exp $	*/
 
 /*-
@@ -33,58 +33,17 @@
 #define	_EWS4800MIPS_INTR_H_
 
-#define IPL_NONE	0	/* disable only this interrupt */
-#define IPL_SOFTCLOCK	1	/* clock software interrupts (SI 0) */
-#define IPL_SOFTBIO	1	/* bio software interrupts (SI 0) */
-#define IPL_SOFTNET	2	/* network software interrupts (SI 1) */
-#define IPL_SOFTSERIAL	2	/* serial software interrupts (SI 1) */
-#define	IPL_VM		3
-#define IPL_SCHED	4	/* disable clock interrupts */
-#define IPL_HIGH	4	/* disable all interrupts */
+#include <mips/intr.h>
 
-#define _IPL_N		5
-
-#define _IPL_SI0_FIRST	IPL_SOFTCLOCK
-#define _IPL_SI0_LAST	IPL_SOFTBIO
-
-#define _IPL_SI1_FIRST	IPL_SOFTNET
-#define _IPL_SI1_LAST	IPL_SOFTSERIAL
-
-#define IST_UNUSABLE	-1	/* interrupt cannot be used */
-#define IST_NONE	0	/* none (dummy) */
-#define IST_PULSE	1	/* pulsed */
-#define IST_EDGE	2	/* edge-triggered */
-#define IST_LEVEL	3	/* level-triggered */
-
-#include <mips/locore.h>
-
-extern const uint32_t *ipl_sr_bits;
-
-#define spl0()		(void) _spllower(0)
-#define splx(s)		(void) _splset(s)
-
-typedef int ipl_t;
-typedef struct {
-	ipl_t _sr;
-} ipl_cookie_t;
-
-static inline ipl_cookie_t
-makeiplcookie(ipl_t ipl)
-{
-
-	return (ipl_cookie_t){._sr = ipl_sr_bits[ipl]};
-}
-
-static inline int
-splraiseipl(ipl_cookie_t icookie)
-{
-
-	return _splraise(icookie._sr);
-}
-
-#include <sys/spl.h>
-
+#ifdef _KERNEL
 void intr_init(void);
 void intr_establish(int, int (*)(void *), void *);
 void intr_disestablish(void *);
 
+#ifdef __INTR_PRIVATE
+extern const struct ipl_sr_map tr2_ipl_sr_map;
+extern const struct ipl_sr_map tr2a_ipl_sr_map;
+#endif
+
+#endif
+
 #endif /* !_EWS4800MIPS_INTR_H_ */
Index: /trunk/src/sys/arch/ews4800mips/include/sbdvar.h
===================================================================
--- /trunk/src/sys/arch/ews4800mips/include/sbdvar.h	(revision 151)
+++ /trunk/src/sys/arch/ews4800mips/include/sbdvar.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: sbdvar.h,v 1.4 2008/04/28 20:23:18 martin Exp $	*/
+/*	$NetBSD: sbdvar.h,v 1.4.18.1 2010/12/29 08:16:22 matt Exp $	*/
 
 /*-
@@ -48,5 +48,5 @@
 
 	/* mainbus node table */
-	const char **mainbusdevs;
+	const char * const *mainbusdevs;
 
 	/* System Board I/O device table */
@@ -69,5 +69,5 @@
 	void *(*intr_establish)(int, int (*)(void *), void *);
 	void (*intr_disestablish)(void *);
-	void (*intr)(uint32_t, uint32_t, uint32_t, uint32_t);
+	void (*intr)(int, vaddr_t, uint32_t);
 
 	/* Interval timer helper routines */
@@ -89,5 +89,5 @@
 void *x ## _intr_establish(int, int (*)(void *), void *);		\
 void x ## _intr_disestablish(void *);					\
-void x ## _intr(uint32_t, uint32_t, uint32_t, uint32_t);		\
+void x ## _intr(int, vaddr_t, uint32_t);				\
 void x ## _initclocks(void);						\
 void x ## _consinit(void);						\
@@ -96,5 +96,4 @@
 void x ## _poweroff(void);						\
 void x ## _ether_addr(uint8_t *);					\
-extern const uint32_t x ## _sr_bits[]
 
 #define	_SBD_OPS_SET(m, x)	platform . x = m ## _ ## x
